<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'chat';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 载入并实例化类库
require (ROOT_PATH . 'include/chat.class.php');
$dou_chat = new Chat();

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 问题列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['chat_question']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['chat_question_add'],
            'href' => 'chat.php?rec=add' 
    ));
    
    // 获取参数
    $class = !$check->is_illegal_char($_REQUEST['class']) ? $_REQUEST['class'] : '';
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
    $answer_id = $check->is_number($_REQUEST['answer_id']) ? $_REQUEST['answer_id'] : '';
 
    $where = $class ? " AND class = '$class'" : ''; // 分组
    if ($keyword) {
        $where = $where . " AND ask LIKE '%$keyword%'";
        $get = '&keyword=' . $keyword;
    }
    if ($answer_id) {
        $where = $where . " AND id IN (" . $dou_chat->in_question_id($answer_id) . ")";
        $get = '&answer_id=' . $answer_id;
    }
 
    // 把第一个AND替换成WHERE
    $where = $dou->where($where);
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('chat_question') . $where . " ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $page_url = 'chat.php' . ($class ? '?class=' . $class : '');
    $limit = $dou->pager($sql, 30, $page, $page_url, $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $add_time = date("Y-m-d", $row['add_time']);
        
        $question_list[] = array (
                "id" => $row['id'],
                "content" => $row['content'],
                "keyword" => $row['keyword'],
                "priority" => $row['priority'],
                "class" => $row['class'] ? $row['class'] : $_LANG['chat_question_class_no'],
                "answer_number" => $dou_chat->answer_number($row['id']),
                "default" => $row['default'] ? true : false,
                "remember" => $row['id'] == $_SESSION[DOU_ID]['question_id'] ? true : false,
                "linked" => $dou->get_one("SELECT id FROM " . $dou->table('chat_qa') . " WHERE answer_id = " . $_SESSION[DOU_ID]['answer_id'] . " AND question_id = '$row[id]'"),
                "add_time" => $add_time 
        );
    }
    
    // 赋值给模板
    $smarty->assign('keyword', $keyword);
    $smarty->assign('class_list', $dou->get_no_repeat_value('chat_question', 'class', $class));
    $smarty->assign('answer', $dou->get_row('chat_answer', '*', "id = '$answer_id'"));
    $smarty->assign('remember', $dou->get_row('chat_answer', '*', "id = '" . $_SESSION[DOU_ID]['answer_id'] . "'"));
    $smarty->assign('question_list', $question_list);
    
    $smarty->display('chat.htm');
} 

/**
 * +----------------------------------------------------------
 * 问题添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['chat_question_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['chat_question'],
            'href' => 'chat.php' 
    ));
     

    // 关联问题
    $answer_id = $check->is_number($_REQUEST['answer_id']) ? $_REQUEST['answer_id'] : '';
    $answer = $dou->get_row('chat_answer', '*', "id = '$answer_id'");
   
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('class_list', $dou->get_no_repeat_value('chat_question', 'class'));
    $smarty->assign('answer', $answer);
    $smarty->assign('question', $question);
    
    $smarty->display('chat.htm');
} 

elseif ($rec == 'insert') {
    // 验证并获取合法的问题ID
    $answer_id = $check->is_number($_REQUEST['answer_id']) ? $_REQUEST['answer_id'] : '';
    
    // 验证问题
    if (empty($_POST['content']))
        $dou->dou_msg($_LANG['chat_question_content'] . $_LANG['is_empty']);
    
    // 数据格式化
    $add_time = time();
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    // 写入问题数据
    $dou->query("INSERT INTO " . $dou->table('chat_question') . " (id, content, keyword, priority, `class`, add_time)" . " VALUES (NULL, '$_POST[content]', '$_POST[keyword]', '$_POST[priority]', '$_POST[class]', '$add_time')");

    // 关联问题和答案
    if ($answer_id) {
        $question_id = $dou->insert_id();
        $dou->query("INSERT INTO " . $dou->table('chat_qa') . " (id, question_id, answer_id, add_time)" . " VALUES (NULL, '$question_id', '$answer_id', '$add_time')");
    }
    
    $dou->create_admin_log($_LANG['chat_question_add'] . ': ' . $_POST['content']);
    $dou->dou_msg($_LANG['chat_question_add_succes'], 'chat.php');
} 

/**
 * +----------------------------------------------------------
 * 问题编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['chat_question_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['chat_question'],
            'href' => 'chat.php' 
    ));
    
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $question = $dou->get_row('chat_question', '*', "id = '$id'");
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('class_list', $dou->get_no_repeat_value('chat_question', 'class', $question['class']));
    $smarty->assign('question', $question);
    
    $smarty->display('chat.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    // 验证问题
    if (empty($_POST['content']))
        $dou->dou_msg($_LANG['chat_question_content'] . $_LANG['is_empty']);
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
 
    $sql = "UPDATE " . $dou->table('chat_question') . " SET content = '$_POST[content]', keyword = '$_POST[keyword]', priority = '$_POST[priority]', `class` = '$_POST[class]' WHERE id = '$id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['chat_question_edit'] . ': ' . $_POST['question']);
    $dou->dou_msg($_LANG['chat_question_edit_succes'], 'chat.php');
}

/**
 * +----------------------------------------------------------
 * 将问题关联到答案
 * +----------------------------------------------------------
 */
elseif ($rec == 'link') {
    // 验证并获取合法的ID
    $answer_id = $check->is_number($_REQUEST['answer_id']) ? $_REQUEST['answer_id'] : '';
    $question_id = $check->is_number($_REQUEST['question_id']) ? $_REQUEST['question_id'] : '';
    
    if (!$dou->get_one("SELECT id FROM " . $dou->table('chat_qa') . " WHERE question_id = '$question_id' AND answer_id = '$answer_id'")) {
        $add_time = time();
        $dou->query("INSERT INTO " . $dou->table('chat_qa') . " (id, question_id, answer_id, add_time)" . " VALUES (NULL, '$question_id', '$answer_id', '$add_time')");
    }
 
    $dou->dou_header('chat.php' . ($_SESSION[DOU_ID]['page'] == 1 ? '' : '?page=' . $_SESSION[DOU_ID]['page']));
}  

/**
 * +----------------------------------------------------------
 * 默认问题
 * +----------------------------------------------------------
 */
elseif ($rec == 'set_default') {
    $question_id = $check->is_number($_REQUEST['question_id']) ? $_REQUEST['question_id'] : '';
    $old_default = $dou->get_one("SELECT `default` FROM " . $dou->table('chat_question') . " WHERE id = '$question_id'");
    
    $default = $old_default ? 0 : 1;
 
    $dou->query("UPDATE " . $dou->table('chat_question') . " SET `default` = '$default' WHERE id = '$question_id'");
    
    $dou->dou_header('chat.php' . ($_SESSION[DOU_ID]['page'] == 1 ? '' : '?page=' . $_SESSION[DOU_ID]['page']));
} 

/**
 * +----------------------------------------------------------
 * 记忆问题
 * +----------------------------------------------------------
 */
elseif ($rec == 'remember') {
    $question_id = $check->is_number($_REQUEST['question_id']) ? $_REQUEST['question_id'] : '';
    
    if ($_SESSION[DOU_ID]['question_id'] == $question_id) {
        $_SESSION[DOU_ID]['question_id'] = '';
    } else {
        $_SESSION[DOU_ID]['question_id'] = $question_id;
    }
    
    $dou->dou_header('chat.php' . ($_SESSION[DOU_ID]['page'] == 1 ? '' : '?page=' . $_SESSION[DOU_ID]['page']));
} 

/**
 * +----------------------------------------------------------
 * 问题删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'cancel_from_answer') {
    // 验证并获取合法的ID
    $answer_id = $check->is_number($_REQUEST['answer_id']) ? $_REQUEST['answer_id'] : '';
    $question_id = $check->is_number($_REQUEST['question_id']) ? $_REQUEST['question_id'] : '';
    
    $dou->delete('qa', "question_id = $question_id AND answer_id = $answer_id", 'chat.php?answer_id=' . $answer_id);
} 

/**
 * +----------------------------------------------------------
 * 问题删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'chat.php');
    $question = $dou->get_one("SELECT question FROM " . $dou->table('chat_question') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm'])) {
        $dou->create_admin_log($_LANG['chat_question_del'] . ': ' . $question);
        $dou->delete('question', "id = $id", 'chat.php');
        $dou->delete('qa', "question_id = $id", 'chat.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $question, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'chat.php', '', '30', "chat.php?rec=del&id=$id");
    }
} 

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'del_all') {
            // 批量问题删除
            $dou->del_all('question', $_POST['checkbox'], 'id');
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        $dou->dou_msg($_LANG['chat_question_select_empty']);
    }
} 

/**
 * +----------------------------------------------------------
 * 参数设置
 * +----------------------------------------------------------
 */
elseif ($rec == 'set') {
    $set_list = array('chat_title', 'chat_welcome', 'chat_mode', 'robot_name', 'human_name', 'chat_email');
    foreach ($set_list as $name) {
        if (!$dou->value_exist('parameter', 'name', $name)) {
            $dou->query("INSERT INTO " . $dou->table('parameter') . " (id, name, lang, value, cue, `group`)" . " VALUES (NULL, '$name', '" . $_LANG['chat_' . $name . '_lang'] . "', '" . $_LANG['chat_' . $name . '_value'] . "', '" . $_LANG['chat_' . $name . '_cue'] . "', 'chat')");
        }
    }
    $dou->dou_header('parameter.php?rec=set&group=chat');
}

?>