<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'chat_answer';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 载入并实例化类库
require (ROOT_PATH . 'include/chat.class.php');
$dou_chat = new Chat();

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 答案列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['chat_answer']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['chat_answer_add'],
            'href' => 'chat_answer.php?rec=add' 
    ));
    
    // 获取参数
    $class = !$check->is_illegal_char($_REQUEST['class']) ? $_REQUEST['class'] : '';
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
    $question_id = $check->is_number($_REQUEST['question_id']) ? $_REQUEST['question_id'] : '';
 
    $where = $class ? " AND class = '$class'" : ''; // 分组
    if ($keyword) {
        $where = $where . " AND ask LIKE '%$keyword%'";
        $get = '&keyword=' . $keyword;
    }
    if ($question_id) {
        $where = $where . " AND id IN (" . $dou_chat->in_answer_id($question_id) . ")";
        $get = '&question_id=' . $question_id;
    }
 
    // 把第一个AND替换成WHERE
    $where = $dou->where($where);
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('chat_answer') . $where . " ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $page_url = 'chat_answer.php' . ($class ? '?class=' . $class : '');
    $limit = $dou->pager($sql, 30, $page, $page_url, $get);
 
    // 将分页计入缓存
    $_SESSION[DOU_ID]['page'] = $page;
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $add_time = date("Y-m-d", $row['add_time']);
        
        $answer_list[] = array (
                "id" => $row['id'],
                "content" => $dou_chat->format_keyword($row['content']),
                "priority" => $row['priority'],
                "question_number" => $dou_chat->question_number($row['id']),
                "default" => $row['default'] ? true : false,
                "remember" => $row['id'] == $_SESSION[DOU_ID]['answer_id'] ? true : false,
                "linked" => $dou->get_one("SELECT id FROM " . $dou->table('chat_qa') . " WHERE question_id = " . $_SESSION[DOU_ID]['question_id'] . " AND answer_id = '$row[id]'"),
                "add_time" => $add_time 
        );
    }
    
    // 赋值给模板
    $smarty->assign('keyword', $keyword);
    $smarty->assign('question', $dou->get_row('chat_question', '*', "id = '$question_id'"));
    $smarty->assign('remember', $dou->get_row('chat_question', '*', "id = '" . $_SESSION[DOU_ID]['question_id'] . "'"));
    $smarty->assign('answer_list', $answer_list);
    
    $smarty->display('chat_answer.htm');
} 

/**
 * +----------------------------------------------------------
 * 答案添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['chat_answer_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['chat_answer'],
            'href' => 'chat_answer.php' 
    ));
    
    // 关联问题
    $question_id = $check->is_number($_REQUEST['question_id']) ? $_REQUEST['question_id'] : '';
    $question = $dou->get_row('chat_question', '*', "id = '$question_id'");
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('question', $question);
    $smarty->assign('answer', $answer);
    
    $smarty->display('chat_answer.htm');
} 

elseif ($rec == 'insert') {
    // 验证并获取合法的问题ID
    $question_id = $check->is_number($_REQUEST['question_id']) ? $_REQUEST['question_id'] : '';
 
    // 验证答案
    if (empty($_POST['content']))
        $dou->dou_msg($_LANG['chat_answer_content'] . $_LANG['is_empty']);
    
    // 数据格式化
    $add_time = time();
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    // 写入答案数据
    $dou->query("INSERT INTO " . $dou->table('chat_answer') . " (id, content, priority, add_time)" . " VALUES (NULL, '$_POST[content]', '$_POST[priority]', '$add_time')");

    // 关联问题和答案
    if ($question_id) {
        $answer_id = $dou->insert_id();
        $dou->query("INSERT INTO " . $dou->table('chat_qa') . " (id, question_id, answer_id, add_time)" . " VALUES (NULL, '$question_id', '$answer_id', '$add_time')");
    }
 
    $dou->create_admin_log($_LANG['chat_answer_add'] . ': ' . $_POST['content']);
    $dou->dou_msg($_LANG['chat_answer_add_succes'], 'chat_answer.php');
} 

/**
 * +----------------------------------------------------------
 * 答案编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['chat_answer_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['chat_answer'],
            'href' => 'chat_answer.php' 
    ));
    
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $answer = $dou->get_row('chat_answer', '*', "id = '$id'");
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('answer', $answer);
    
    $smarty->display('chat_answer.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    // 验证答案
    if (empty($_POST['content']))
        $dou->dou_msg($_LANG['chat_answer_content'] . $_LANG['is_empty']);
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
 
    $sql = "UPDATE " . $dou->table('chat_answer') . " SET content = '$_POST[content]', priority = '$_POST[priority]' WHERE id = '$id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['chat_answer_edit'] . ': ' . $_POST['content']);
    $dou->dou_msg($_LANG['chat_answer_edit_succes'], 'chat_answer.php');
}

/**
 * +----------------------------------------------------------
 * 将问题关联到答案
 * +----------------------------------------------------------
 */
elseif ($rec == 'link') {
    // 验证并获取合法的ID
    $answer_id = $check->is_number($_REQUEST['answer_id']) ? $_REQUEST['answer_id'] : '';
    $question_id = $check->is_number($_REQUEST['question_id']) ? $_REQUEST['question_id'] : '';
    
    if (!$dou->get_one("SELECT id FROM " . $dou->table('chat_qa') . " WHERE question_id = '$question_id' AND answer_id = '$answer_id'")) {
        $add_time = time();
        $dou->query("INSERT INTO " . $dou->table('chat_qa') . " (id, question_id, answer_id, add_time)" . " VALUES (NULL, '$question_id', '$answer_id', '$add_time')");
    }
 
    $dou->dou_header('chat_answer.php' . ($_SESSION[DOU_ID]['page'] == 1 ? '' : '?page=' . $_SESSION[DOU_ID]['page']));
}  

/**
 * +----------------------------------------------------------
 * 记忆答案
 * +----------------------------------------------------------
 */
elseif ($rec == 'remember') {
    $answer_id = $check->is_number($_REQUEST['answer_id']) ? $_REQUEST['answer_id'] : '';
    
    if ($_SESSION[DOU_ID]['answer_id'] == $answer_id) {
        $_SESSION[DOU_ID]['answer_id'] = '';
    } else {
        $_SESSION[DOU_ID]['answer_id'] = $answer_id;
    }
    
    $dou->dou_header('chat_answer.php' . ($_SESSION[DOU_ID]['page'] == 1 ? '' : '?page=' . $_SESSION[DOU_ID]['page']));
} 

/**
 * +----------------------------------------------------------
 * 答案删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'cancel_from_question') {
    // 验证并获取合法的ID
    $answer_id = $check->is_number($_REQUEST['answer_id']) ? $_REQUEST['answer_id'] : '';
    $question_id = $check->is_number($_REQUEST['question_id']) ? $_REQUEST['question_id'] : '';
    
    $dou->delete('qa', "question_id = '$question_id' AND answer_id = '$answer_id'", 'chat_answer.php?question_id=' . $question_id);
}   

/**
 * +----------------------------------------------------------
 * 默认问题
 * +----------------------------------------------------------
 */
elseif ($rec == 'set_default') {
    $answer_id = $check->is_number($_REQUEST['answer_id']) ? $_REQUEST['answer_id'] : '';
    $old_default = $dou->get_one("SELECT `default` FROM " . $dou->table('chat_answer') . " WHERE id = '$answer_id'");
    
    $default = $old_default ? 0 : 1;
 
    $dou->query("UPDATE " . $dou->table('chat_answer') . " SET `default` = '$default' WHERE id = '$answer_id'");
    
    $dou->dou_header('chat_answer.php' . ($_SESSION[DOU_ID]['page'] == 1 ? '' : '?page=' . $_SESSION[DOU_ID]['page']));
} 

/**
 * +----------------------------------------------------------
 * 答案删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'chat_answer.php');
    $answer = $dou->get_one("SELECT answer FROM " . $dou->table('chat_answer') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm'])) {
        $dou->create_admin_log($_LANG['chat_answer_del'] . ': ' . $answer);
        $dou->delete('answer', "id = $id");
        $dou->delete('qa', "answer_id = $id", 'chat_answer.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $answer, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'chat_answer.php', '', '30', "chat_answer.php?rec=del&id=$id");
    }
} 

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'del_all') {
            // 批量答案删除
            $dou->del_all('answer', $_POST['checkbox'], 'id');
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        $dou->dou_msg($_LANG['chat_answer_select_empty']);
    }
}

?>