<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'chat_keyword';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 载入并实例化类库
require (ROOT_PATH . 'include/chat.class.php');
$dou_chat = new Chat();

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 关键字列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['chat_keyword']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['chat_keyword_add'],
            'href' => 'chat_keyword.php?rec=add' 
    ));
    
    // 获取参数
    $text = isset($_REQUEST['text']) ? trim($_REQUEST['text']) : '';
 
    if ($text) {
        $where = " WHERE ask LIKE '%$text%'";
        $get = '&text=' . $text;
    }
 
    // 把第一个AND替换成WHERE
    $where = $dou->where($where);
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('chat_keyword') . $where . " ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $page_url = 'chat_keyword.php' . ($class ? '?class=' . $class : '');
    $limit = $dou->pager($sql, 15, $page, $page_url, $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $add_time = date("Y-m-d", $row['add_time']);
        $guide = $row['guide'];
        
        $keyword_list[] = array (
                "id" => $row['id'],
                "text" => $row['text'],
                "type" => $row['type'],
                "guide" => $guide,
                "add_time" => $add_time 
        );
    }
    
    // 赋值给模板
    $smarty->assign('text', $text);
    $smarty->assign('keyword_list', $keyword_list);
    
    $smarty->display('chat_keyword.htm');
} 

/**
 * +----------------------------------------------------------
 * 关键字添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['chat_keyword_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['chat_keyword'],
            'href' => 'chat_keyword.php' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('type_list', $dou_chat->get_keyword_type_list());
    
    $smarty->display('chat_keyword.htm');
} 

elseif ($rec == 'insert') {
    // 验证关键字
    if (empty($_POST['text']))
        $dou->dou_msg($_LANG['chat_keyword_text'] . $_LANG['is_empty']);
    
    // 数据格式化
    $add_time = time();
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "INSERT INTO " . $dou->table('chat_keyword') . " (id, text, type, guide, add_time)" . " VALUES (NULL, '$_POST[text]', '$_POST[type]', '$_POST[guide]', '$add_time')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['chat_keyword_add'] . ': ' . $_POST['text']);
    $dou->dou_msg($_LANG['chat_keyword_add_succes'], 'chat_keyword.php');
} 

/**
 * +----------------------------------------------------------
 * 关键字编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['chat_keyword_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['chat_keyword'],
            'href' => 'chat_keyword.php' 
    ));
    
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $keyword = $dou->get_row('chat_keyword', '*', "id = '$id'");
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('type_list', $dou_chat->get_keyword_type_list($keyword['type']));
    $smarty->assign('keyword', $keyword);
    
    $smarty->display('chat_keyword.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    // 验证关键字
    if (empty($_POST['text']))
        $dou->dou_msg($_LANG['chat_keyword_text'] . $_LANG['is_empty']);
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
 
    $sql = "UPDATE " . $dou->table('chat_keyword') . " SET text = '$_POST[text]', type = '$_POST[type]', guide = '$_POST[guide]' WHERE id = '$id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['chat_keyword_edit'] . ': ' . $_POST['text']);
    $dou->dou_msg($_LANG['chat_keyword_edit_succes'], 'chat_keyword.php');
}

/**
 * +----------------------------------------------------------
 * 关键字删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'chat_keyword.php');
    $text = $dou->get_one("SELECT text FROM " . $dou->table('chat_keyword') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm'])) {
        $dou->create_admin_log($_LANG['chat_keyword_del'] . ': ' . $text);
        $dou->delete('chat_keyword', "id = $id", 'chat_keyword.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $text, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'chat_keyword.php', '', '30', "chat_keyword.php?rec=del&id=$id");
    }
} 

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'del_all') {
            // 批量关键字删除
            $dou->del_all('chat_keyword', $_POST['checkbox'], 'id');
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        $dou->dou_msg($_LANG['chat_keyword_select_empty']);
    }
}

?>