<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'chat_service';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 载入并实例化类库
require (ROOT_PATH . 'include/chat.class.php');
$dou_chat = new Chat('server');

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 对话记录列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['chat_service']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['chat_service_add'],
            'href' => 'chat_service.php?rec=add' 
    ));
    
    // 获取参数
    $time_start = isset($_REQUEST['time_start']) ? trim($_REQUEST['time_start']) : '';
    $time_end = isset($_REQUEST['time_end']) ? trim($_REQUEST['time_end']) : '';
    
    // 筛选
    if ($time_start) {
        $where = $where . " AND add_time > '" . strtotime($time_start) . "'";
        $get = '&time_start=' . $time_start;
    }
    if ($time_end) {
        $where = $where . " AND add_time < '" . strtotime($time_end) . "'";
        $get = '&time_end=' . $time_end;
    }
 
    // 把第一个AND替换成WHERE
    $where = $dou->where($where);
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('chat_service') . $where . " ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 35, $page, 'chat_service.php', $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $service_list[] = array (
                "id" => $row['id'],
                "chat_mode" => $row['chat_mode'],
                "client_id" => $row['client_id'],
                "first_time" => date("Y-m-d H:i:s", $row['first_time']),
                "last_time" => date("Y-m-d H:i:s", $row['last_time']),
                "online" => time() - $row['last_time'] < 30*60 ? true : false,
                "url" => $dou->param($dou->rewrite_url('chat') . '&chat_sn=' . $row['chat_sn']),
                "first_ip" => $row['first_ip'],
                "last_ip" => $row['last_ip'],
                "os" => $row['os'],
                "lang" => $row['lang'],
                "browser" => $row['browser']
        );
    }
    
    // 赋值给模板
    $smarty->assign('keyword', $keyword);
    $smarty->assign('service_list', $service_list);
    
    $smarty->display('chat_service.htm');
} 

/**
 * +----------------------------------------------------------
 * 对话记录添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'record') {
    $smarty->assign('ur_here', $_LANG['chat_service_record']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['chat_service'],
            'href' => 'chat_service.php' 
    ));
    
    // 验证并获取合法的ID
    $service_id = $check->is_number($_REQUEST['service_id']) ? $_REQUEST['service_id'] : '';
    
    // 读取记录
    $where = " WHERE service_id = '$service_id'";
    $sql = "SELECT * FROM " . $dou->table('chat_service_recorde') . $where . " ORDER BY id ASC";
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $create_time = date("Y-m-d H:i:s", $row['create_time']);

        $recorde_list[] = array (
                "id" => $row['id'],
                "type" => $row['type'],
                "head" => $dou_chat->name($row['from']) . ' ' . $create_time,
                "content" => $dou_chat->format_keyword($row['content']),
                "create_time" => $create_time,
                "ip" => $row['ip']
        );
    }
    
    $smarty->assign('recorde_list', $recorde_list);
    
    $smarty->display('chat_service.htm');
} 

?>