<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

if (!defined('REWRITE')) {
    $_CUR = 'index';
    require (dirname(__FILE__) . '/include/init.php');
}
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 判断是客服端还是客户端
if ($check->is_letter_number($chat_sn = $_REQUEST['chat_sn'])) {
    $service_id = $dou->get_one("SELECT id FROM " . $dou->table('chat_service') . " WHERE chat_sn = '$chat_sn'");
    $smarty->assign('work_mode', $work_mode = 'server');
} else {
    $smarty->assign('work_mode', $work_mode = 'client');
    $_LANG['chat_from_client_robot'] = $_PARAM['robot_name'] ? $_PARAM['robot_name'] : $_LANG['chat_from_client_robot'];
    $_LANG['chat_from_client_human'] = $_PARAM['human_name'] ? $_PARAM['human_name'] : $_LANG['chat_from_client_human'];
}

// 载入并实例化类库
require (ROOT_PATH . 'include/chat.class.php');
$dou_chat = new Chat($work_mode);

// 初始化
$client_id = $dou_chat->mac();
$chat_title = $_PARAM['chat_title'] ? $_PARAM['chat_title'] : ($work_mode == 'server' ? $_LANG['chat_work_human'] . $service_id : $_LANG['chat']);
$welcome = $_PARAM['chat_welcome'] ? $_PARAM['chat_welcome'] : $_LANG['chat_welcome'];
$chat_mode = $_SESSION[DOU_ID]['chat_mode'] ? $_SESSION[DOU_ID]['chat_mode'] : ($_PARAM['chat_mode'] ? $_PARAM['chat_mode'] : 'robot');

if ($service_id) { // 人工客服，实时更新接听服务时间
    $service_time = time();
    $dou->query("UPDATE " . $dou->table('chat_service') . " SET service_time = '$service_time' WHERE id = '$service_id'");
} elseif ($dou->value_exist('chat_service', 'client_id', $client_id)) { // 如果已经建立会话，则实时更新最后在线时间
    $last_time = time();
    $last_ip = $dou->get_ip();

    $dou->query("UPDATE " . $dou->table('chat_service') . " SET chat_mode = '$chat_mode', last_time = '$last_time', last_ip = '$last_ip' WHERE client_id = '$client_id'");
}

// 赋值给模板-meta和title信息
$smarty->assign('page_title', $dou->page_title('', '', $_PARAM['chat_title']));
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle'));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

/**
 * +----------------------------------------------------------
 * 首页
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    // 默认问题
    $sql = "SELECT * FROM " . $dou->table('chat_question') . " WHERE `default` = '1' ORDER BY id ASC";
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $question_list[] = array (
                "id" => $row['id'],
                "content" => $row['content']
        );
    }
    
    // 赋值给模板-数据
    $smarty->assign('question_list', $question_list);
    $smarty->assign('chat_title', $chat_title);
    $smarty->assign('head', $chat_mode == 'robot' ? $_LANG['chat_from_client_robot'] : $_LANG['chat_from_client_human']);
    $smarty->assign('welcome', $welcome);
    $smarty->assign('chat_mode', $chat_mode);
    $smarty->assign('chat_sn', $chat_sn);
    $smarty->assign('now_time', date("Y-m-d H:i:s", time()));

    $smarty->display('chat.dwt');
}

/**
 * +----------------------------------------------------------
 * 提问
 * +----------------------------------------------------------
 */
elseif ($rec == 'ask') {
    // 获取问题ID
    if ($_POST['word'] && !$check->is_illegal_char($_POST['word'])) {
        $word = $_POST['word'];
    } else {
        $data['wrong'] = '输入有误';
        echo json_encode($data);
        exit;
    }
    $question_id = $dou->get_one("SELECT id FROM " . $dou->table('chat_question') . " WHERE content LIKE '%$word%' ORDER BY RAND(), priority ASC, id ASC");

    // 根据问题获取答案
    $answer_id = $dou->get_one("SELECT answer_id FROM " . $dou->table('chat_qa') . " WHERE question_id = '$question_id' ORDER BY RAND(), id ASC");

    // 无回复时显示
    if (!$answer_id) {
        $answer_id = $dou->get_one("SELECT id FROM " . $dou->table('chat_answer') . " WHERE `default` = '1' ORDER BY RAND(), priority ASC, id ASC");
    }

    $answer_content = $dou->get_one("SELECT content FROM " . $dou->table('chat_answer') . " WHERE id = '$answer_id'");

    // 首先判断是否已经有建立的回话
    if ($dou->value_exist('chat_service', 'client_id', $client_id)) {
        $service_id = $dou->get_one("SELECT id FROM " . $dou->table('chat_service') . " WHERE client_id = '$client_id'");
    } else {
        // 格式化
        $chat_sn = $dou_chat->rand_chat_sn($client_id);
        $first_time = $last_time = time();
        $first_ip = $last_ip = $dou->get_ip();
        $os = $dou_chat->os();
        $lang = $dou_chat->lang();
        $browser = $dou_chat->browser();

        $dou->query("INSERT INTO " . $dou->table('chat_service') . " (id, chat_mode, chat_sn, client_id, first_time, last_time, first_ip, last_ip, os, lang, browser)" . " VALUES (NULL, '$chat_mode', '$chat_sn', '$client_id', '$first_time', '$last_time', '$first_ip', '$last_ip', '$os', '$lang', '$browser')");

        $service_id = $dou->insert_id();
    }
 
    // 人工模式需要将会话状态标记为未读
    if ($chat_mode == 'human') {
        $dou->query("UPDATE " . $dou->table('chat_service') . " SET if_read = '0' WHERE id = '$service_id'");
        
        // 根据客服接听时间，判断是否发送邮件提醒
        $service = $dou->get_row('chat_service', 'service_time, send_email_time', "id = '$service_id'");
       
        // 如果客服从未接听或者最后一次更新时间超过5分钟则发送邮件提醒
        if (!$service['service_time'] || (time() - $service['service_time'] > 5*60 && time() - $service['send_email_time'] > 5*60)) {
            $chat_url = $dou->param($_URL['chat'] . '&chat_sn=' . $row['chat_sn']);
            $body = $_LANG['chat_email_custom_number'] . $service_id . '<br>' . $_LANG['chat_email_body'] . '<br><a href="' . $chat_url . '">' . $chat_url . '</a>';
            $dou->send_mail($_PARAM['chat_email'], $_LANG['chat_email_title'], $body);
         
            $send_email_time = time();
            $dou->query("UPDATE " . $dou->table('chat_service') . " SET send_email_time = '$send_email_time' WHERE id = '$service_id'");
        }
    }
    
    // 数据格式化
    $create_time = time();
    $ip = $dou->get_ip();

    // 写入提问数据
    $dou->query("INSERT INTO " . $dou->table('chat_service_recorde') . " (id, client_id, service_id, `from`, type, item_id, content, create_time, ip)" . " VALUES (NULL, '$client_id', '$service_id', 'custom', 'question', '$question_id', '$word', '$create_time', '$ip')");

    // 写入答案数据
    if ($answer_content) {
        $dou->query("INSERT INTO " . $dou->table('chat_service_recorde') . " (id, client_id, service_id, `from`, type, item_id, content, create_time, ip)" . " VALUES (NULL, '$client_id', '$service_id', 'robot', 'answer', '$answer_id', '$answer_content', '$create_time', '$ip')");

        if ($related_question = $dou_chat->related_question($question_id))
            $answer_content .= '<p class="related">' . $_LANG['chat_related'] . $related_question . '</p>';

        $answer[] = array (
                "head" => $dou_chat->name('robot') . ' ' . date("Y-m-d H:i:s", $create_time),
                "content" => $dou_chat->format_keyword($answer_content)
        );
    }

    $data['answer'] = $answer;

    echo json_encode($data);
}

/**
 * +----------------------------------------------------------
 * 关键字
 * +----------------------------------------------------------
 */
elseif ($rec == 'key') {
    // 获取问题ID
    if (!$check->is_illegal_char($_POST['keyword'])) {
        $keyword = $_POST['keyword'];
    } else {
        $data['wrong'] = '输入有误';
        echo json_encode($data);
        exit;
    }

    // 首先判断是否已经有建立的回话
    if ($dou->value_exist('chat_service', 'client_id', $client_id)) {
        $service_id = $dou->get_one("SELECT id FROM " . $dou->table('chat_service') . " WHERE client_id = '$client_id'");
    } else {
        // 格式化
        $chat_sn = $dou_chat->rand_chat_sn($client_id);
        $first_time = $last_time = time();
        $first_ip = $last_ip = $dou->get_ip();
        $os = $dou_chat->os();
        $lang = $dou_chat->lang();
        $browser = $dou_chat->browser();

        $dou->query("INSERT INTO " . $dou->table('chat_service') . " (id, chat_mode, chat_sn, client_id, first_time, last_time, first_ip, last_ip, os, lang, browser)" . " VALUES (NULL, '$chat_mode', '$chat_sn', '$client_id', '$first_time', '$last_time', '$first_ip', '$last_ip', '$os', '$lang', '$browser')");

        $service_id = $dou->insert_id();
    }

    // 检索关键词对应的内容
    $data = $dou->get_row('chat_keyword', '*', "text = '$keyword'");
    if ($data) {
        if ($data['type'] == 'text') {
            $content = $data['text'];
        } elseif ($data['type'] == 'question') {
            $item_id = $data['guide'];
            $question = $dou->get_row('chat_question', '*', "id = '$item_id'");
            $content = $question['content'];
        } elseif ($data['type'] == 'answer') {
            $item_id = $data['guide'];
            $answer = $dou->get_row('chat_answer', '*', "id = '$item_id'");
            $content = $answer['content'];
        } elseif ($data['type'] == 'link') {
            $content = '<a href="' . $data['guide'] . '">' . $data['text'] . '</a>';
        }
    }

    // 数据格式化
    $create_time = time();
    $ip = $dou->get_ip();
    $item_id = $item_id ? $item_id : 0;

    // 写入答案数据
    if ($content) {
        $dou->query("INSERT INTO " . $dou->table('chat_service_recorde') . " (id, client_id, service_id, `from`, type, item_id, content, create_time, ip)" . " VALUES (NULL, '$client_id', '$service_id', 'robot', '$data[type]', '$item_id', '$content', '$create_time', '$ip')");

        $answer[] = array (
                "head" => $dou_chat->name('robot') . ' ' . date("Y-m-d H:i:s", $create_time),
                "content" => $dou_chat->format_keyword($content)
        );
    }

    $data['answer'] = $answer;

    echo json_encode($data);
}

/**
 * +----------------------------------------------------------
 * 读取记录
 * +----------------------------------------------------------
 */
elseif ($rec == 'recorde') {
    // 格式化
    $last_time = time();
    $last_ip = $dou->get_ip();

    $dou->query("UPDATE " . $dou->table('chat_service') . " SET last_time = '$last_time', last_ip = '$last_ip' WHERE id = '$service_id'");
 
    $where = " WHERE client_id = '$client_id'";
    $sql = "SELECT * FROM " . $dou->table('chat_service_recorde') . $where . " ORDER BY id ASC";
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $create_time = date("Y-m-d H:i:s", $row['create_time']);

        $recorde_list[] = array (
                "id" => $row['id'],
                "type" => $row['type'],
                "head" => $dou_chat->name($row['from']) . ' ' . $create_time,
                "content" => $dou_chat->format_keyword($row['content']),
                "create_time" => $create_time,
                "ip" => $row['ip']
        );
    }

    $data['recorde_list'] = $recorde_list;

    echo json_encode($data);
}

/**
 * +----------------------------------------------------------
 * 人工客服
 * +----------------------------------------------------------
 */
elseif ($rec == 'mode') {
    if ($_SESSION[DOU_ID]['chat_mode'] == 'human' && $_POST['chat_mode'] != 'human') {
        $_SESSION[DOU_ID]['chat_mode'] = 'robot';
        $data['btn_human_class'] = 'btn-human';
        $data['chat_mode'] = 'robot';
        $data['head'] = $dou_chat->name('robot');
        $data['content'] = $_LANG['chat_robot_welcome'];
    } else {
        $_SESSION[DOU_ID]['chat_mode'] = 'human';
        $data['btn_human_class'] = 'btn-human-on';
        $data['chat_mode'] = 'human';
        $data['head'] = $dou_chat->name('human');
        $data['content'] = $_LANG['chat_human_welcome'];
    }
    
    echo json_encode($data);
}

/**
 * +----------------------------------------------------------
 * 获取新回答
 * +----------------------------------------------------------
 */
elseif ($rec == 'get_new_answer') {
    $service_id = $dou->get_one("SELECT id FROM " . $dou->table('chat_service') . " WHERE client_id = '$client_id'");
    $new_answer = $dou_chat->get_new_answer($service_id);
    
    // 写入答案数据
    if ($new_answer) {
        $answer[] = array (
                "head" => $dou_chat->name('human') . ' ' . date("Y-m-d H:i:s", $new_answer['create_time']),
                "content" => $dou_chat->format_keyword($new_answer['content'])
        );
    }

    $data['answer'] = $answer;

    echo json_encode($data);
}

/**
 * +----------------------------------------------------------
 * 人工回复
 * +----------------------------------------------------------
 */
elseif ($rec == 'reply') {
    // 获取问题ID
    if ($_POST['word'] && !$check->is_illegal_char($_POST['word'])) {
        $word = $_POST['word'];
    } else {
        $data['wrong'] = '输入有误';
        echo json_encode($data);
        exit;
    }
 
    // 人工模式需要将会话状态标记为未读
    if ($chat_mode == 'human') {
        $dou->query("UPDATE " . $dou->table('chat_service') . " SET if_read = '0' WHERE id = '$service_id'");
    }

    // 数据格式化
    $create_time = time();
    $ip = $dou->get_ip();
    $client_id = $dou->get_one("SELECT client_id FROM " . $dou->table('chat_service') . " WHERE id = '$service_id'");

    // 写入回答数据
    $dou->query("INSERT INTO " . $dou->table('chat_service_recorde') . " (id, client_id, service_id, `from`, type, item_id, content, create_time, ip)" . " VALUES (NULL, '$client_id', '$service_id', 'human', 'answer', '1', '$word', '$create_time', '$ip')");

    echo json_encode(array());
}

/**
 * +----------------------------------------------------------
 * 获取新问题
 * +----------------------------------------------------------
 */
elseif ($rec == 'get_new_question') {
    $service_id = $dou->get_one("SELECT id FROM " . $dou->table('chat_service') . " WHERE client_id = '$client_id'");
    $new_question = $dou_chat->get_new_question($service_id);
    
    // 写入答案数据
    if ($new_question) {
        $question[] = array (
                "head" => $dou_chat->name('custom') . ' ' . date("Y-m-d H:i:s", $new_question['create_time']),
                "content" => $dou_chat->format_keyword($new_question['content'])
        );
    }

    $data['question'] = $question;

    echo json_encode($data);
}

?>