<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
if (!defined('IN_DOUCO')) {
    die('Hacking attempt');
}
class Chat {
    private $work_mode; // 工作模式
                        
    // 构造函数
    function __construct($work_mode = '') {
        $this->work_mode = $work_mode;
    }
 
    // 构造函数.兼容PHP4
    function Chat($work_mode = '') {
        $this->__construct($work_mode);
    }
 
    /**
     * +----------------------------------------------------------
     * 随机对话编号
     * +----------------------------------------------------------
     */
    function rand_chat_sn($client_id) {
        $chat_sn = md5($client_id . $GLOBALS['dou']->create_rand_string('number', 4));
        if ($GLOBALS['dou']->value_exist('chat_service', 'chat_sn', $chat_sn)) {
            $this->rand_chat_sn();
        } else {
            return $chat_sn;
        }
    }
    
    /**
     * +----------------------------------------------------------
     * 统计答案数量
     * +----------------------------------------------------------
     * $question_id 问题ID
     * +----------------------------------------------------------
     */
    function answer_number($question_id) {
        $answer_number = $GLOBALS['dou']->num_rows($GLOBALS['dou']->query("SELECT * FROM " . $GLOBALS['dou']->table('chat_qa') . " WHERE question_id = '$question_id'"));
     
        return $answer_number ? $answer_number : 0;
    }
 
    /**
     * +----------------------------------------------------------
     * 统计答案数量
     * +----------------------------------------------------------
     * $question_id 问题ID
     * +----------------------------------------------------------
     */
    function question_number($answer_id) {
        $answer_number = $GLOBALS['dou']->num_rows($GLOBALS['dou']->query("SELECT * FROM " . $GLOBALS['dou']->table('chat_qa') . " WHERE answer_id = '$answer_id'"));
     
        return $answer_number ? $answer_number : 0;
    }
 
    /**
     * +----------------------------------------------------------
     */
    function in_answer_id($question_id) {
        $data = $GLOBALS['dou']->fn_query("SELECT * FROM " . $GLOBALS['dou']->table('chat_qa') . " WHERE question_id = '$question_id'");
        $i=0;
        foreach ((array) $data as $value) {
            $in_answer_id .= ($i == 0 ? '' : ',') . $value['answer_id'];
            $i++;
        }

        return $in_answer_id;
    }
 
    /**
     * +----------------------------------------------------------
     */
    function in_question_id($answer_id) {
        $data = $GLOBALS['dou']->fn_query("SELECT * FROM " . $GLOBALS['dou']->table('chat_qa') . " WHERE answer_id = '$answer_id'");
        $i=0;
        foreach ((array) $data as $value) {
            $in_question_id .= ($i == 0 ? '' : ',') . $value['question_id'];
            $i++;
        }

        return $in_question_id;
    }
 
    /**
     * +----------------------------------------------------------
     * 关键字类型
     * +----------------------------------------------------------
     */
    function get_keyword_type_list($current_type = '') {
        $type_array = array('text', 'answer');
        
        foreach ($type_array as $value) {
            $type_list[] = array (
                    "value" => $value,
                    "name" => $GLOBALS['_LANG']['chat_keyword_type_' . $value],
                    "cur" => $value == $current_type ? true : false,
            );
        }
        
        return $type_list;
    }
 
    /**
     * +----------------------------------------------------------
     * 获取新回答
     * +----------------------------------------------------------
     * $service_id 会话ID
     * +----------------------------------------------------------
     */
    function get_new_answer($service_id) {
        $if_read = $GLOBALS['dou']->get_one("SELECT if_read FROM " . $GLOBALS['dou']->table('chat_service') . " WHERE id = '$service_id'");
     
        if (!$if_read) {
            $recorde = $GLOBALS['dou']->get_row('chat_service_recorde', '*', "service_id = '$service_id' ORDER BY id DESC");

            if ($recorde['type'] == 'answer') {
                // 标记会话状态为已阅读
                $GLOBALS['dou']->query("UPDATE " . $GLOBALS['dou']->table('chat_service') . " SET if_read = '1' WHERE id = '$service_id'");
                
                return $recorde;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
 
    /**
     * +----------------------------------------------------------
     * 获取新问题
     * +----------------------------------------------------------
     * $service_id 会话ID
     * +----------------------------------------------------------
     */
    function get_new_question($service_id) {
        $if_read = $GLOBALS['dou']->get_one("SELECT if_read FROM " . $GLOBALS['dou']->table('chat_service') . " WHERE id = '$service_id'");
     
        if (!$if_read) {
            $recorde = $GLOBALS['dou']->get_row('chat_service_recorde', '*', "service_id = '$service_id' ORDER BY id DESC");

            if ($recorde['type'] == 'question') {
                // 标记会话状态为已阅读
                $GLOBALS['dou']->query("UPDATE " . $GLOBALS['dou']->table('chat_service') . " SET if_read = '1' WHERE id = '$service_id'");
                
                return $recorde;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
 
    /**
     * +----------------------------------------------------------
     * 名称
     * +----------------------------------------------------------
     * $service_id 会话ID
     * +----------------------------------------------------------
     */
    function name($from) {
        return $name = $GLOBALS['_LANG']['chat_from_' . $this->work_mode . '_' . $from];
    }
    
    /**
     * +----------------------------------------------------------
     * 关键字格式化
     * +----------------------------------------------------------
     */
    function format_keyword($content = '') {
        return $content = preg_replace('/<strong>(.*)<\/strong>/Ums', '<b class="key" data-key="$1">$1</b>', $content);
    }
 
    /**
     * +----------------------------------------------------------
     * 你可能还想问
     * +----------------------------------------------------------
     */
    function related_question($question_id) {
        $class = $GLOBALS['dou']->get_one("SELECT class FROM " . $GLOBALS['dou']->table('chat_question') . " WHERE id = '$question_id' ORDER BY RAND() LIMIT 5");
     
        if ($class) {
            $_SESSION[DOU_ID]['class'] = $class;

            $sql = "SELECT * FROM " . $GLOBALS['dou']->table('chat_question') . " WHERE class = '$class' AND id != '$question_id'";
            $query = $GLOBALS['dou']->query($sql);
            while ($row = $GLOBALS['dou']->fetch_array($query)) {
                $related_question .= '<b class="que" data-que="' . $row['content'] . '">' . $row['content'] . '</b> ';
            }

            return $related_question;
        }
    }
 
    /**
     * +----------------------------------------------------------
     * 获取访客语言：简体中文、繁體中文、English。 
     * +----------------------------------------------------------
     */
    function lang() {   
        $Lang = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 4);
        //使用substr()截取字符串，从 0 位开始，截取4个字符
        if (preg_match('/zh-c/i',$Lang)) {
        //preg_match()正则表达式匹配函数    
            $Lang = '简体中文';
        }
        elseif (preg_match('/zh/i',$Lang)) {
            $Lang = '繁體中文';
        }
        else {
            $Lang = 'English';
        }
        return $Lang;
    }
    
    /**
     * +----------------------------------------------------------
     * 获取访客浏览器：MSIE、Firefox、Chrome、Safari、Opera、Other 
     * +----------------------------------------------------------
     */
    function browser() {
        $Browser = $_SERVER['HTTP_USER_AGENT'];
        if (preg_match('/MSIE/i',$Browser)) {
            $Browser = 'MSIE';
        }
        elseif (preg_match('/Firefox/i',$Browser)) {
            $Browser = 'Firefox';
        }
        elseif (preg_match('/Chrome/i',$Browser)) {
            $Browser = 'Chrome';
        }
        elseif (preg_match('/Safari/i',$Browser)) {
            $Browser = 'Safari';
        }
        elseif (preg_match('/Opera/i',$Browser)) {
            $Browser = 'Opera';
        }
        else {
            $Browser = 'Other';
        }
        return $Browser;
    }
    
    /**
     * +----------------------------------------------------------
     * 获取访客操作系统：Windows、MAC、Linux、Unix、BSD、Other
     * +----------------------------------------------------------
     */
    function os() {
        $OS = $_SERVER['HTTP_USER_AGENT'];
        if (preg_match('/win/i',$OS)) {
            $OS = 'Windows';
        }
        elseif (preg_match('/mac/i',$OS)) {
            $OS = 'MAC';
        }
        elseif (preg_match('/linux/i',$OS)) {    
            $OS = 'Linux';    
        }    
        elseif (preg_match('/unix/i',$OS)) {    
            $OS = 'Unix';    
        }    
        elseif (preg_match('/bsd/i',$OS)) {    
            $OS = 'BSD';    
        }    
        else {    
            $OS = 'Other';    
        }    
        return $OS;    
    }
 
    /**
     * +----------------------------------------------------------
     * 获取网卡的MAC地址，目前支持WIN/LINUX系统
     * +----------------------------------------------------------
     */
    function mac() {
        switch (strtolower(PHP_OS)) {
            case "linux":
                @exec("ifconfig -a", $return_array);
                break;
            case "solaris":
                break;
            case "unix":
                break;
            case "aix":
                break;
            default:
                @exec("ipconfig /all", $return_array);
                if (!$return_array) {
                    $ipconfig = $_SERVER[ "WINDIR" ] . "\system32\ipconfig.exe";
                    if (is_file($ipconfig)) {
                        @exec($ipconfig . " /all", $return_array);
                    } else {
                        @exec($_SERVER[ "WINDIR" ] . "\system\ipconfig.exe /all", $return_array);
                    }
                }
                break;
        }
        
        $temp_array = array();
        foreach ($return_array as $value) {
            if (preg_match("/[0-9a-f][0-9a-f][:-]" . "[0-9a-f][0-9a-f][:-]" . "[0-9a-f][0-9a-f][:-]" . "[0-9a-f][0-9a-f][:-]" . "[0-9a-f][0-9a-f][:-]" . "[0-9a-f][0-9a-f]/i", $value, $temp_array)) {
                $mac = $temp_array[0];
                break;
            }
        }
        
        unset($temp_array);
        return $mac;
    }
 
}

?>