/**
 +----------------------------------------------------------
 */
$(document).ready(function() {
    $(".chat-scroll").scrollTop($(".chat-scroll")[0].scrollHeight);
    
    // 关键字
    $(".chat-scroll").on('click', '.que', function() {
        ask($(this).data("que"));
    });
    
    // 关键字
    $(".chat-scroll").on('click', '.key', function() {
        key($(this).data("key"));
    });
 
    // 设置初始高度
    $(".chat-scroll").height($(window).height() - 90 - 160 - 45); // chat-head高度 chat-ask高度 chat-scroll的padding高度
    $(window).resize(function(){
      $(".chat-scroll").height($(window).height() - 90 - 160 - 45);
    });
});

/**
 +----------------------------------------------------------
 */
var vm = new Vue({
    el:'#chat-box',
    data:{
        word:'',
        recorde_list:'',
        answer:'',
        btn_human_class:chat_mode == 'robot' ? 'btn-human' : 'btn-human-on',
        chat_mode:chat_mode,
        work_mode:work_mode,
        chat_sn:chat_sn,
        wrong:'',
        intervalId: null
    },
    
    mounted: function () {
        if (this.work_mode == 'server') {
            console.log('客服模式');
            this.recorde(); // 服务端模式自动载入历史记录
            this.serverRefreh(); // 服务端模式自动刷新
        } else {
            // 人工模式下自动刷新
            if (this.chat_mode == 'human') {
                this.clientRefreh();
            }
        }

        //将Vue方法传到全局对象window中
        window.key = this.key;
        window.ask = this.ask;
        window.reply = this.reply;
    },
    
    methods:{
        // 载入历史记录
        recorde:function() {
            this.$http.post('?rec=recorde',{chat_sn:this.chat_sn},{emulateJSON:true}).then(function(res){
                if (res.data.wrong) {
                    alert(res.data.wrong);
                }
                
                if (res.data.recorde_list) {
                    this.recorde_list = res.data.recorde_list;
                    $(document).ready(function() {
                        $(".chat-scroll").scrollTop($(".chat-scroll")[0].scrollHeight);
                        $(".btnHistory").css('display', 'none');
                    });
                }
            },function(res){
                console.log('失败')
            })
        },
        
        // 用户提问
        ask:function(keyword) {
            var word = keyword ? keyword : this.word;
         
            // 人工模式
            if (word == '人工' || word == '人工客服') {
                this.mode('human');
            }
         
            this.$http.post('?rec=ask',{word:word},{emulateJSON:true}).then(function(res) {
                if (res.data.wrong) {
                    alert(res.data.wrong);
                    return false;
                }
             
                this.answer = res.data.answer;
                
                // 先显示问题
                if (!keyword) {
                    $(".chat-scroll").append('<div class="chat-msg"><div class="question"><div class="head">您 ' + this.date(new Date()) + '</div><div class="msg">' + word + '</div></div></div>');
                    $(document).ready(function() {
                        $(".chat-scroll").scrollTop($(".chat-scroll")[0].scrollHeight);
                    });
                }
                
                // 延迟显示答案
                if (res.data.answer && this.chat_mode == 'robot') {
                    setTimeout(function () {
                        $(".chat-scroll").append('<div class="chat-msg"><div class="answer"><div class="head">' + res.data.answer[0].head + '</div><div class="msg">' + res.data.answer[0].content + '</div></div></div>');
                        $(document).ready(function() {
                            $(".chat-scroll").scrollTop($(".chat-scroll")[0].scrollHeight);
                        });
                    }, 500);
                }
                
                this.word = '';
            },function(res){
                console.log('失败')
            })
        },
        
        // 用户关键字点击
        key:function(keyword) {
            // 人工模式
            if (keyword == '人工' || keyword == '人工客服') {
                this.mode('human');
            }
            
            this.$http.post('?rec=key',{keyword:keyword},{emulateJSON:true}).then(function(res){
                if (res.data.wrong) {
                    alert(res.data.wrong);
                    return false;
                }
             
                this.answer = res.data.answer;
             
                //console.log(res.data.answer);
                $(".chat-scroll").append('<div class="chat-msg"><div class="answer"><div class="head">' + res.data.answer[0].head + '</div><div class="msg">' + res.data.answer[0].content + '</div></div></div>');
                
                $(document).ready(function() {
                    $(".chat-scroll").scrollTop($(".chat-scroll")[0].scrollHeight);
                });
            },function(res){
                console.log('失败')
            })
        },
     
        // 客户端定时刷新
        clientRefreh() {
            // 计时器正在进行中，退出函数
            if (this.intervalId != null) {
                return;
            }
            // 计时器为空，操作
            this.intervalId = setInterval(() => {
                console.log("刷新" + this.chat_mode);
                this.$http.post('?rec=get_new_answer',{},{emulateJSON:true}).then(function(res) {
                    if (res.data.wrong) {
                        alert(res.data.wrong);
                        return false;
                    }
                    
                    // 延迟显示答案
                    if (res.data.answer) {
                        setTimeout(function () {
                            $(".chat-scroll").append('<div class="chat-msg"><div class="answer"><div class="head">' + res.data.answer[0].head + '</div><div class="msg">' + res.data.answer[0].content + '</div></div></div>');
                            $(document).ready(function() {
                                $(".chat-scroll").scrollTop($(".chat-scroll")[0].scrollHeight);
                            });
                        }, 500);
                    }
                },function(res){
                    console.log('失败')
                })
            }, 5000);
        }, 
        
        // 切换成人工客服
        mode:function(chat_mode) {
            this.$http.post('?rec=mode',{chat_mode:chat_mode},{emulateJSON:true}).then(function(res){
                if (res.data.wrong) {
                    alert(res.data.wrong);
                    return false;
                }
                console.log(res.data.chat_mode);
                this.btn_human_class = res.data.btn_human_class;
                this.chat_mode = res.data.chat_mode;
                
                $(".chat-scroll").append('<div class="chat-msg"><div class="question"><div class="head">' + res.data.head + ' ' + this.date(new Date()) + '</div><div class="msg">' + res.data.content + '</div></div></div>');
                $(document).ready(function() {
                    $(".chat-scroll").scrollTop($(".chat-scroll")[0].scrollHeight);
                });
                    
                // 人工模式下自动刷新
                if (this.chat_mode == 'human') {
                    // 开启自动刷新
                    this.clientRefreh();
                } else {
                    this.clear();
                }
            },function(res) {
                console.log('失败')
            })
        },
        
        // 人工客服回答
        reply:function() {
            var word = this.word;
            this.$http.post('?rec=reply',{chat_sn:this.chat_sn, word:word},{emulateJSON:true}).then(function(res) {
                if (res.data.wrong) {
                    alert(res.data.wrong);
                    return false;
                }
             
                this.answer = res.data.answer;
                
                // 先显示问题
                if (word) {
                    $(".chat-scroll").append('<div class="chat-msg"><div class="answer"><div class="head">您 ' + this.date(new Date()) + '</div><div class="msg">' + word + '</div></div></div>');
                    $(document).ready(function() {
                        $(".chat-scroll").scrollTop($(".chat-scroll")[0].scrollHeight);
                    });
                }
                
                this.word = '';
            },function(res){
                console.log('失败')
            })
        },
     
        // 服务端定时刷新
        serverRefreh() {
            // 计时器正在进行中，退出函数
            if (this.intervalId != null) {
                return;
            }
            // 计时器为空，操作
            this.intervalId = setInterval(() => {
                console.log("刷新" + this.chat_sn);
                this.$http.post('?rec=get_new_question',{chat_sn:this.chat_sn},{emulateJSON:true}).then(function(res) {
                    if (res.data.wrong) {
                        alert(res.data.wrong);
                        return false;
                    }
                    
                    // 延迟显示答案
                    if (res.data.question) {
                        setTimeout(function () {
                            $(".chat-scroll").append('<div class="chat-msg"><div class="question"><div class="head">' + res.data.question[0].head + '</div><div class="msg">' + res.data.question[0].content + '</div></div></div>');
                            $(document).ready(function() {
                                $(".chat-scroll").scrollTop($(".chat-scroll")[0].scrollHeight);
                            });
                        }, 500);
                    }
                },function(res){
                    console.log('失败')
                })
            }, 5000);
        }, 

        // 停止定时器
        clear() {
            clearInterval(this.intervalId); //清除计时器
            this.intervalId = null; //设置为null
        },
        
        // 重新加载
        reload:function() {
            location.reload();;
        },
        
        // 弹出信息
        innerHTML:function(e) {
            this.ask(e.target.innerHTML)
        },
     
        //时间转换
        date:function(d, sign) {
          //如果没有传递符号，给一个默认的符号
          if (!sign) {
            sign = '-'
          }
          //获取d里面年月日时分秒
          let year = d.getFullYear(),
            month = d.getMonth() + 1,
            sun = d.getDate(),
            hours = d.getHours(),
            minutes = d.getMinutes(),
            seconds = d.getSeconds()

          return (
            year +
            sign +
            this.mendZero(month) +
            sign +
            this.mendZero(sun) +
            ' ' +
            this.mendZero(hours) +
            ':' +
            this.mendZero(minutes) +
            ':' +
            this.mendZero(seconds)
          )
        },

        //时间转换补零
        mendZero:function(num) {
            return (num = num < 10 ? '0' + num : num)
        },
    },
    
    destroyed() {
        // 在页面销毁后，清除计时器
        this.clear();
    }
})